var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-11-09\">\n\
      <meta name=\"topicid\" content=\"GUID-CC5EDDD2-4331-4CF8-863F-9DDDA90A343D\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>オブジェクトの作成と操作</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CC5EDDD2-4331-4CF8-863F-9DDDA90A343D\"></a><div class=\"head\">\n\
            <h1>オブジェクトの作成と操作</h1>\n\
         </div>\n\
         <p><a name=\"GUID-7D3DC885-71CC-4AB1-BCB0-3F51CA1D6A7D\"></a>コマンド プラグインのコンテキストでは、オブジェクトの作成と操作は Maya の元に戻す/やり直しシステムに密接に関連付けられています。実際には、<span class=\"char_link\"><a href=\"#!/url=./files/GUID-A9070270-9B5D-4511-8012-BC948149884D.htm\">ディペンデンシー グラフ</a></span>とそのノードの状態を操作するコマンドは(<span class=\"char_link\"><a href=\"#!/url=./files/GUID-0B85C721-C3C6-47D7-9D85-4F27B787ABB6.htm\">DAG</a></span> を含みます)、「元に戻す」操作を実装してアクションを元に戻し、Maya の内部状態が「元に戻す」スタックと同期するようにする必要があります。このトピックでは、元に戻すことが可能なコマンド内でオブジェクトを作成して操作する方法を例示します。\n\
            \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_E64345777DC5412CB713CC00F86933E0\"></a> \n\
            <h2><a name=\"GUID-F51945E7-F04F-4C24-9556-4AC29AE4E68D\"></a>元に戻すことが可能なコマンドのサンプル\n\
            </h2> \n\
            <p><a name=\"GUID-C5F41770-7DA6-4B43-9F60-D51ED5836777\"></a>最初に、元に戻すことが可能なコマンドの構造を示します。後で、カメラを作成して操作する、元に戻すことが可能なコマンドを示します。 \n\
            </p> <a name=\"SECTION_25749785FDB240F09ED24BB7F7C4B68A\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-335663FA-EFA3-4790-A39B-EA458F67D882\"></a><span class=\"collapsible-section-title\">Python API 2.0:</span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleUndoableCommand.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
\n\
kPluginCmdName = \'myUndoableCommandName\'\n\
\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyUndoableCommand( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a> ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\'\n\
        \n\
        # ... Perform any object creation here, since doIt() is only called once per command instance ...\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # ... Perform any object manipulation here ...\n\
        pass\n\
    \n\
    \n\
    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # ... Reverse any object creation or manipulations here ...\n\
        pass\n\
    \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return MyUndoableCommand() \n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'pySampleUndoableCommand.py\' )\n\
cmds.myUndoableCommandName()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
            <p><a name=\"GUID-BB767225-EFEA-461F-A5D0-809C6E299597\"></a></p> <a name=\"SECTION_F01868A8877F470CB7CC5AF81911D694\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-A95A6C2A-1322-4C3A-BD08-B2F7B7733A5C\"></a><span class=\"collapsible-section-title\">Python API 1.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleUndoableCommand.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myUndoableCommandName\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyUndoableCommand( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\'\n\
        \n\
        # ... Perform any object creation here, since doIt() is only called once per command instance ...\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # ... Perform any object manipulation here ...\n\
        pass\n\
    \n\
    \n\
    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # ... Reverse any object creation or manipulations here ...\n\
        pass\n\
    \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( MyUndoableCommand() )\n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleUndoableCommand.py\' )\n\
cmds.myUndoableCommandName()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
            <p><a name=\"GUID-149E5B76-2F5C-40C3-8C6C-9DF8EEABA328\"></a>前述のコマンド プラグインには、コマンド実行プロセス中に Maya によって呼び出される 4 つの重要な関数が含まれます。 \n\
            </p> <a name=\"UL_57EB8FE290B14C80BEAA36FDDB2CB4F7\"></a><ul>\n\
               <li><em class=\"strong\">isUndoable()</em>: コマンドの <span class=\"code\" translate=\"no\">isUndoable()</span> 関数が <span class=\"code\" translate=\"no\">True</span> を返す場合、そのコマンドのインスタンスは Maya の「元に戻す」スタックに追加されます。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True</pre></div> \n\
               </li>\n\
               <li><em class=\"strong\">doIt()</em>: 各コマンド インスタンスの <span class=\"code\" translate=\"no\">doIt()</span> 関数は、コマンドが最初に実行されるときに 1 回<em class=\"mild\"></em>呼び出されます。コードを最大限に再利用するには、コマンド インスタンスで必要なすべてのオブジェクトと変数を <span class=\"code\" translate=\"no\">doIt()</span> 関数でインスタンス化し、その後で <span class=\"code\" translate=\"no\">doIt()</span> 関数本体内から <span class=\"code\" translate=\"no\">redoIt()</span> を呼び出すことをお勧めします。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\'\n\
        \n\
        # Parse any arguments when doIt() is invoked.\n\
        self.parseArgs( args )\n\
        \n\
        # ... Perform any object creation here, since doIt() is only called once per command instance ...\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()</pre></div> \n\
               </li>\n\
               <li><em class=\"strong\">redoIt()</em>: <span class=\"code\" translate=\"no\">redoIt()</span> 関数は、コマンドが再実行されるたびに Maya によって呼び出されます。したがって、コマンドで使用されているオブジェクトの状態を操作するには、<span class=\"code\" translate=\"no\">redoIt ()</span> を使用する必要があります。この状態操作は、<span class=\"code\" translate=\"no\">undoIt()</span> 関数で元に戻す必要があることに留意してください。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # ... Perform any object manipulation here ...\n\
        pass</pre></div> \n\
               </li>\n\
               <li><em class=\"strong\">undoIt()</em>: <span class=\"code\" translate=\"no\">undoIt()</span> 関数は、コマンドが元に戻されると呼び出されます。<span class=\"code\" translate=\"no\">undoIt()</span> 関数の目的は、コマンドによって操作される各オブジェクトが、コマンドの実行前に戻った状態を保持することです。コマンドのインスタンスが操作を正しく元に戻さない場合、Maya\n\
                  の内部状態が、元に戻す/やり直しスタックと矛盾します。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # ... Reverse any object creation or manipulations here ...\n\
        pass</pre></div> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2B9A7DF0170D4A84A6EFB8E085526C51\"></a> \n\
            <h2><a name=\"GUID-1C993EF3-E1F7-4D67-8F40-148BBF008C1B\"></a>MDagModifier でオブジェクトを作成する\n\
            </h2> \n\
            <p><a name=\"GUID-F68EC6D3-9DBB-40B3-BE29-14899DEE3C07\"></a> DAG ノードの作成および DAG ノードの操作を元に戻すことを容易にするため、Maya API には <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span> クラスが用意されています。このクラスの派生元は <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDGModifier</a></span> であり、ディペンデンシー グラフ ノードの作成と操作に使用されます。DAG はディペンデンシー グラフのサブセットなので、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDGModifier</a></span> によって提供される関数は、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span> によっても提供されます。これを覚えておくと、このトピックの <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span> に対して行われる関数呼び出しのクラス マニュアルを参照するときに役立つ場合があります。 \n\
            </p> \n\
            <p><a name=\"GUID-0FCA13B3-339F-4169-830F-598922633299\"></a>次の元に戻すことができるコマンドでは、カメラを作成して操作し、この新しく作成したカメラに現在のビューを設定しています。 \n\
            </p> <a name=\"SECTION_D93B978184014BBB9746006AD55B2246\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-717AB321-F291-4359-AEF7-8EA8845EEA0A\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleCameraCommand.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
import maya.api.OpenMayaUI as OpenMayaUI\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
	\n\
kPluginCmdName = \'myCameraCommand\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCameraCommand( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a> ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\' \n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagModifier</a>()\n\
        \n\
        # Create the camera transform node.\n\
        self.cameraTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.dagModifier.renameNode( self.cameraTransformObj, \'myCameraTransform\' )\n\
        \n\
        # Create the camera shape node as a child of the camera transform node.\n\
        self.cameraShapeObj = self.dagModifier.createNode( \'camera\', self.cameraTransformObj )\n\
        self.dagModifier.renameNode( self.cameraShapeObj, \'myCameraShape\' )\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier. This effectively\n\
        # creates the DAG nodes specified using self.dagModifier.createNode().\n\
        self.dagModifier.doIt()\n\
        \n\
        # Set the translation value of the camera\'s transform node. \n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        self.previousCamera=currentView.getCamera() # self.previousCamera is now populated with the current camera before we switch.\n\
        \n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>( self.cameraShapeObj )\n\
        cameraDagPath = dagNodeFn.getPath()\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
    \n\
    \n\
    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # Switch back to the previous camera. We do not have to reverse the translation of \n\
        # self.cameraTransformObj because it will be excluded from the DAG once \n\
        # self.dagModifier.undoIt() is called below.\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        self.previousCamera = currentView.getCamera()\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        self.dagModifier.undoIt()\n\
    \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return  MyCameraCommand() \n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'pySampleCameraCommand.py\' )\n\
cmds.myCameraCommand()\n\
cmds.undo()\n\
cmds.redo()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_44A9F3DA26DC4818B5EB6343EEF6B04A\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-D5904EBA-08F3-48C0-B25A-6550024B64EA\"></a><span class=\"collapsible-section-title\">Python API 1.0:</span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCameraCommand.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaUI as OpenMayaUI\n\
\n\
kPluginCmdName = \'myCameraCommand\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCameraCommand( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\' \n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagModifier</a>()\n\
        \n\
        # Create the camera transform node.\n\
        self.cameraTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.dagModifier.renameNode( self.cameraTransformObj, \'myCameraTransform\' )\n\
        \n\
        # Create the camera shape node as a child of the camera transform node.\n\
        self.cameraShapeObj = self.dagModifier.createNode( \'camera\', self.cameraTransformObj )\n\
        self.dagModifier.renameNode( self.cameraShapeObj, \'myCameraShape\' )\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier. This effectively\n\
        # creates the DAG nodes specified using self.dagModifier.createNode().\n\
        self.dagModifier.doIt()\n\
        \n\
        # Set the translation value of the camera\'s transform node. \n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        currentView.getCamera( self.previousCamera ) # self.previousCamera is now populated with the current camera before we switch.\n\
        \n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>( self.cameraShapeObj )\n\
        dagNodeFn.getPath( cameraDagPath )\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
    \n\
    \n\
    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # Switch back to the previous camera. We do not have to reverse the translation of \n\
        # self.cameraTransformObj because it will be excluded from the DAG once \n\
        # self.dagModifier.undoIt() is called below.\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        currentView.setCamera( self.previousCamera )\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        self.dagModifier.undoIt()\n\
    \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( MyCameraCommand() )\n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCameraCommand.py\' )\n\
cmds.myCameraCommand()\n\
cmds.undo()\n\
cmds.redo()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
            <p><a name=\"GUID-0069A4EE-714E-476D-BC6B-A89E16709B20\"></a>上の例では、主要な関数は <span class=\"code\" translate=\"no\">MDagModifer.createNode()</span>、<span class=\"code\" translate=\"no\">MDagModifier.doIt()</span>、<span class=\"code\" translate=\"no\">MDagModifier.undoIt()</span> です。これらの関数は、それぞれコマンドの <span class=\"code\" translate=\"no\">doIt()</span> メソッド、<span class=\"code\" translate=\"no\">redoIt()</span> メソッド、<span class=\"code\" translate=\"no\">undoIt()</span> メソッドで使用されています。 \n\
            </p> <a name=\"OL_D8BAD32F6184474396861909BEB88C4C\"></a><ol type=\"1\" start=\"1\">\n\
               <li><em class=\"strong\">MDagModifier.createNode()</em>: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.createNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a35eec45cc82c334793c92b08ff4fc1f4&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.createNode()</a></span> が呼び出されると、操作が <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span> 内でキューに入れられて、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> のインスタンスが返されます。この <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> は、DAG に<em class=\"mild\"></em>まだ含まれていない、新しく作成された Maya DAG ノードへのハンドルです。1 番目のパラメータとして文字列を受け取る <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.createNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a35eec45cc82c334793c92b08ff4fc1f4&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.createNode()</a></span> のメソッド シグネチャを呼び出していることに注意してください。この文字列は、作成されたノード タイプの名前を示します。有効なノード タイプ名は、<em class=\"strong\">『Maya ユーザ ガイド』 &gt; 「テクニカル ドキュメント」 &gt; 「ノード」</em>に列記されています。「<span class=\"code\" translate=\"no\">transform</span>」や「<span class=\"code\" translate=\"no\">camera</span>」などです。<span class=\"code\" translate=\"no\">MDagModifier.renameNode()</span> の呼び出しも <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span> 内でキューに入れられ、ノードの名前変更を実行する/元に戻すために使用されます。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\' \n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagModifier</a>()\n\
        \n\
        # Create the camera transform node.\n\
        self.cameraTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.dagModifier.renameNode( self.cameraTransformObj, \'myCameraTransform\' )\n\
        \n\
        # Create the camera shape node as a child of the camera transform node.\n\
        self.cameraShapeObj = self.dagModifier.createNode( \'camera\', self.cameraTransformObj )\n\
        self.dagModifier.renameNode( self.cameraShapeObj, \'myCameraShape\' )\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()</pre></div> \n\
               </li>\n\
               <li><em class=\"strong\">MDagModifier.doIt()</em>: <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> が呼び出されると、前にキューに入れられた操作が効果的に実行されます。キューに入れられた <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.createNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a35eec45cc82c334793c92b08ff4fc1f4&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.createNode()</a></span> 操作は、作成されたノードを DAG に追加することによって完了します。コマンドの <span class=\"code\" translate=\"no\">redoIt()</span> メソッドの <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> を呼び出すと、コマンドの <span class=\"code\" translate=\"no\">doIt()</span> メソッドで定義されている、作成されたノードの同じセットを操作できます。コマンドの <span class=\"code\" translate=\"no\">redoIt()</span> メソッドを呼び出すときに新しいノードを繰り返し作成していないことに注意してください。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier.\n\
        self.dagModifier.doIt()\n\
        \n\
        # ... object manipulations ...</pre></div> \n\
                  <div><a name=\"GUID-DF76C976-2FC8-407D-A84D-B4E55C9B4E20\"></a><div class=\"note-note\"><span class=\"label label-target-language\">注:</span><span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> は同じコマンドで何回でも呼び出すことができます。これはノードを切断して削除する必要がある場合に必要になります。詳細については、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDGModifier</a></span> クラスのマニュアルを参照してください。 \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li><em class=\"strong\">MDagModifier.undoIt()</em>: <span class=\"code\" translate=\"no\">MDagModifier.undoIt()</span> を呼び出すと、<span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> の呼び出しで完了しているすべてのキューに入れられた操作が元に戻されます。 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # ... revert object manipulations ...\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations queued within the MDagModifier.\n\
        self.dagModifier.undoIt()</pre></div> \n\
                  <div><a name=\"GUID-14A8B138-F586-4079-9201-6664FC10CE13\"></a><div class=\"note-note\"><span class=\"label label-target-language\">注:</span>コマンド内での <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> の呼び出し回数に関係なく、<span class=\"code\" translate=\"no\">MDagModifier.undoIt()</span> の呼び出しは 1 回だけで十分です。 \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
            </ol> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_3DB28C1401934FE380114A8ED85C9B45\"></a> \n\
            <h2><a name=\"GUID-81DE13A2-F6BA-4A99-9CBE-1B213FF752E2\"></a>オブジェクトの操作\n\
            </h2> \n\
            <p><a name=\"GUID-F9ED6F86-C956-451E-A0D1-28B69C96AA4E\"></a>このコマンドの <span class=\"code\" translate=\"no\">redoIt()</span> メソッドの本体では、<span class=\"code\" translate=\"no\">MFnCamera.setTranslation()</span> を呼び出してカメラのトランスフォーム ノードの位置を変更します。 \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # ...\n\
        \n\
        # Set the translation value of the camera\'s transform node. \n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        \n\
        # ...</pre></div> \n\
            <p><a name=\"GUID-4331A63D-A28A-4699-A798-27F8855FD53A\"></a>これは、Maya API での <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> および<em class=\"mild\"></em>関数セットの使用を導入しています。 \n\
            </p> <a name=\"UL_A01732147AA14888BEAF26DF27093BB8\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-C40B612B-6F1A-4317-ADFD-882A14042261\"></a><em class=\"strong\">Maya オブジェクト(<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>)</em>: Maya API は、Maya オブジェクトへのアクセスを <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> ラッパ クラスのインスタンスとして提供します。したがって、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> のインスタンスは、カメラ、ライト、メッシュ、変換、およびディペンデンシー グラフ ノードを表すことができます。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> の内部状態は、互換性のある<em class=\"mild\"></em>関数セット(<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase</a></span> から派生されるクラス)を使用して操作します。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> のすべてのインスタンスは、ただ 1 つの Maya オブジェクト タイプ(<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject.apiType()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html#a07b8aba7153df126d2d56334abcad1ae&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject.apiType()</a></span>)を持つか(例: <span class=\"code\" translate=\"no\">MFn.kTransform</span>)、または<em class=\"mild\"></em>関数セットの複数のタイプと互換性がある場合がある <span class=\"code\" translate=\"no\">MFn.kCamera</span> を持ちます。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject.hasFn()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html#a5affad7c61e40a3e6973ab49cd2cca72&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject.hasFn()</a></span> メソッドは、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> のインスタンスと特定の関数セットとの間に互換性があるかどうかを判定します。 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-A6900C10-B578-4BC3-9708-36B82F45A6BB\"></a><em class=\"strong\">関数セット(<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase</a></span> およびサブクラス)</em>: <em class=\"mild\"></em>関数セットは、互換性のある <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> の状態を操作するために Maya API で提供されています。シングルトンとして存在します。つまり、Maya の内部には各タイプの<em class=\"mild\"></em>関数セットが 1 つだけ含まれます。<em class=\"mild\"></em>関数セットは一度に 1 つの <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> だけを操作できますが、このオブジェクトは <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase.setObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html#af1795cba5c81a4ee10680210b71630c6&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase.setObject()</a></span> を使用して変更できます。特定の<em class=\"mild\"></em>関数セットのリファレンスは、そのコンストラクタを使用して取得します。コンストラクタは、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> を受け入れて現在の作業オブジェクトを設定できます。 \n\
                  </p> \n\
                  <p><a name=\"GUID-8E09055F-1B6B-49F7-9C18-5B93C7EAEA6C\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> の関数セットの互換性は、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase</a></span> クラスまでのクラス階層に従います。したがって、<span class=\"code\" translate=\"no\">MFn.kCamera</span> の Maya オブジェクト タイプを持つ <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> のインスタンスは、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera</a></span>、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a></span>、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDependencyNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDependencyNode</a></span>、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase</a></span> との互換性があります。 \n\
                  </p> \n\
                  <p><a name=\"GUID-AF417BA4-936B-4A1E-AD55-BE2F297C82D4\"></a>次のコード サンプルと図は、互換性のある <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> (<span class=\"code\" translate=\"no\">Mfn.kTransform</span> タイプ)の移動を設定するための <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnTransform</a></span> <em class=\"mild\"></em> 関数セットの使用を示しています。つまり、前に <span class=\"code\" translate=\"no\">self.cameraTransformObj</span> に割り当てて <span class=\"code\" translate=\"no\">\'myCameraTransform\'</span> という名前を設定したトランスフォーム ノードです。 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># Set the translation value of the camera\'s transform node. \n\
transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )</pre></div> <img src=\"images/GUID-13626E8D-6F17-4E47-97C8-64EBC321DF28-low.png\"> \n\
                  <div><a name=\"GUID-451D1E95-4043-4C99-B613-6D185CDA0A20\"></a><div class=\"note-note\"><span class=\"label label-target-language\">注:</span><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnTransform.setTranslation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html#a5b9618d6d1e974b011d5ce6ba6684890&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnTransform.setTranslation()</a></span> の呼び出しの 2 番目のパラメータ(<span class=\"code\" translate=\"no\">OpenMaya.MSpace.kTransform</span>)では、移動をトランスフォーム ノードのローカル座標空間内で適用する必要があることを指定しています。 \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_106239DA0CB44E7EA586E810327491F4\"></a> \n\
            <h2><a name=\"GUID-A33EFA40-C785-4F9B-B23A-E5A7C6A677F1\"></a>警告: MDagModifier を使用しないノードを作成、操作する\n\
            </h2> \n\
            <p><a name=\"GUID-569D9BC1-936B-4701-A692-46FE16DA9821\"></a><em class=\"mild\"></em>関数セットの多くでは、<span class=\"code\" translate=\"no\">create()</span> 関数(例: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera.create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html#acf98cd8b37cd4f7747e624e05de34d8b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera.create()</a></span>)も提供されており、これは自動的に適切なシェープとトランスフォーム ノードをインスタンス化します。これらの関数は、シーンを初期化など、1 回だけ使用する、元に戻せないコマンド内でのみ使用することをお勧めします。このガイドラインの例外は\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh.create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html#a3571e84c33d2411e2909e1c6108e27f7&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh.create()</a></span> で、コマンドでのその使用は<span class=\"char_link\"><a href=\"#!/url=./files/GUID-D92830AD-7CB7-4FDD-B008-2AF1F11F0CD6.htm\">例: シーンの作成</a></span>で示されています。この例では、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.createNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a35eec45cc82c334793c92b08ff4fc1f4&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.createNode()</a></span> で親トランスフォーム ノードを作成し、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh.create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html#a3571e84c33d2411e2909e1c6108e27f7&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh.create()</a></span> を使用してその下の子ノードとしてメッシュ データを定義する必要があります。 \n\
            </p> \n\
            <p><a name=\"GUID-11202B04-D123-461D-AE9B-8DBF72B52F88\"></a>同様に、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a></span> <em class=\"mild\"></em> 関数セットには、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode.addChild()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html#a8f50db4c5e3e3ce8bf198ab8debfb91a&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode.addChild()</a></span>、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode.removeChild()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html#a91fb5496562cdd1886aca26ff9887942&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode.removeChild()</a></span>、その他の DAG 回想操作関数が含まれます。1 回使用の元に戻せないコマンドを作成していない場合、またはコマンドの <span class=\"code\" translate=\"no\">undoIt()</span> ロジックを手動で実装してこれらのアクションを元に戻す場合は、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.reparentNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a9c3459407b5cc1da796cbcd6c6f751cb&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.reparentNode()</a></span> 関数を使用してから <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> を呼び出すことをお勧めします。 \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6833493CE06A4D148D4D99AC30D56CA6\"></a> \n\
            <h2><a name=\"GUID-CE98FC7B-4939-461C-A5C5-6BF089576EFB\"></a>警告: MGlobal.deleteNode() でのノード削除\n\
            </h2> \n\
            <p><a name=\"GUID-7A16F304-0396-4E09-A552-1A03ED75F02F\"></a>また、コマンドの <span class=\"code\" translate=\"no\">undoIt()</span> メソッドの中で <span class=\"code\" translate=\"no\">MGlobal.deleteNode()</span> を呼び出してコマンドのノード作成を元に戻すことがあります。これはお勧めできません。<span class=\"code\" translate=\"no\">MGlobal.deleteNode()</span> を呼び出すと、実際は MEL ノード削除コマンドが内部的に実行され、それによってコマンドを元に戻すプロセスの間に「元に戻す」スタックにコマンドが追加されるからです。これにより\n\
               Maya の「元に戻す」スタック内に矛盾が発生し、クラッシュが発生することがあります。 \n\
            </p> \n\
            <p><a name=\"GUID-8A9B92F3-34EE-421A-A28C-813F1E7657E2\"></a> \n\
               <div><a name=\"GUID-BFD53AEF-CBAC-4819-9F74-4656701B612C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">注:</span>同じ理由で、コマンド プラグイン内で <span class=\"code\" translate=\"no\">maya.cmds</span> 関数を呼び出すことをお勧めしません。代わりの安全な方法としては、<span class=\"code\" translate=\"no\">MDagModifier.commandToExecute()</span> 関数を使用して MEL コマンドをキューに加えると、<span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> が呼び出されたときに安全に実行されます。同じ MEL コマンドは <span class=\"code\" translate=\"no\">MDagModifier.undoIt()</span> を呼び出すと安全に元に戻るので、Maya 内の「元に戻す」スタックの不整合を避けることができます。詳細は、「<span class=\"char_link\"><a href=\"#!/url=./files/GUID-6031DE26-93CE-445A-AED9-C27C659268E5.htm\">例: IK ジョイント チェーンを作成する</a></span>」を参照してください。 \n\
                  </div>\n\
               </div> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";