var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-11-09\">\n\
      <meta name=\"topicid\" content=\"GUID-D406310F-086C-4D33-8AF3-023692E7A50F\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>OpenMP</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D406310F-086C-4D33-8AF3-023692E7A50F\"></a><div class=\"head\">\n\
            <h1>OpenMP</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7100\"></a> \n\
            <h2><a name=\"GUID-0B1CEFDA-886F-4777-A0A8-B548F1C6F1CF\"></a>OpenMP の概要\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FF\"></a>OpenMP は、主にデータの並列処理用に設計された高レベルのスレッド抽象であり、<em class=\"strong\">for</em> ループに適用されます。これは、VS2005 とすべてのプラットフォームの Intel コンパイラでサポートされます。OSX 版と Linux 版の Maya で必要な\n\
               gcc のバージョンは、OpenMP をサポートしていません。 \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FE\"></a>OpenMP はコンパイラ プラグマを介して実装されます。ネイティブ スレッドと比較すると、非常にシンプルなインタフェースです。スレッドの作成と管理のすべてとデータ\n\
               パーティション作成の大部分は、ユーザに対して表示されません。OpenMP は、初めて並列領域が発生したときに作成されるスレッド プールを使用します(このため、OpenMP\n\
               コードのプロファイル時にアプリケーションで最初のループ トラバースを無視することが重要です)。 \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FD\"></a>以下に、スレッド化ループの簡単な例を示します。 \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#pragma omp parallel for\n\
for(int i=0; i&lt;imax; i++) {\n\
    doThreadsafeWork(i);\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FC\"></a>このコードは、コンパイラによって変換され、複数スレッド(既定では論理プロセッサごとに 1 スレッド)によって並列で実行される関数になります。最初のプロセッサはループの最初の(imax/numThreads)要素を取り、2\n\
               番目のプロセッサは次の同等サイズのチャンク、というふうに続きます。これにより、優れた<em class=\"strong\">キャッシュ アフィニティ</em>が実現し、プロセッサ通常は隣接するデータ要素を処理するため、キャッシュ ミスを最小限に抑ることができます。 \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FB\"></a>以下に、より複雑な例を示します。 \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#pragma omp parallel for schedule(guided) if(imax&gt;1000)\n\
for(int i=0; i&lt;imax; i++) {\n\
&nbsp;&nbsp;&nbsp;&nbsp;doThreadsafeWork(i);\n\
&nbsp;&nbsp;&nbsp;&nbsp;#pragma omp critical\n\
&nbsp;&nbsp;&nbsp;&nbsp;doNonThreadsafeWork(i);\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FA\"></a>このコードもループをチャンクに分割しますが、guided スケジュール設定オプションによってサイズ(imax/numThreads)よりも小さいチャンクが使用され、既存のチャンクが完了すると新しいチャンクが各スレッドに送られます。これにより、ループの繰り返し間で作業負荷が異なる場合に、実行時に追加チャンクが早期に完了するスレッドに割り当てられるため、<em class=\"strong\">負荷のバランス</em>が改善されます。<span class=\"code\" translate=\"no\">critical</span> プラグマは、後続ラインにロックを配置しています。 \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F9\"></a>メイン プラグマの <span class=\"code\" translate=\"no\">if</span> 条件によって、トリップ数(ループの繰り返し回数)が指定した値を超えた場合にのみ、ループは並列で実行されます。並列領域のコールにはオーバーヘッドがあるため、トリップ数が小さすぎるときに評価を並列にしても意味はありません。有用な経験則として、並列領域の開始と終了に\n\
               1 万クロック サイクルのオーバーヘッドを想定し、カットオフ トリップ数がこの処理を上回るようにすることをお勧めします。これは特に Maya のようなアプリケーションで重要です。Maya\n\
               では、単一の非常に複雑なオブジェクトでも多数の非常に単純なオブジェクトでも同じアルゴリズムが実行される場合があります。後者の場合、数千もの非常に短いスレッド化評価のため余計な起動時オーバーヘッドが生じてスレッド化の利点がすべて帳消しになり、カットオフのないスレッド化コードで大幅に処理速度が低下する可能性があります。スレッド化が条件によって中断されない場合でも、ループ内部のコードはコンパイラによって個別の関数に抽出されるため、関数コールの影響を受けます。\n\
               \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70F8\"></a> \n\
            <h2><a name=\"GUID-C5CE05AD-6FA6-4AC8-9477-9FD557BD6465\"></a>OpenMP の利点と欠点\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F7\"></a>OpenMP の利点は、クロスプラットフォームのサポート、実装と削除が容易であることです。プラグマを無効にするだけでコードは順次形式に戻るため、動作が同じであることをすばやく確認することができます。上記の例のような非常に単純な\n\
               OpenMP プラグマを使用すると、非常に大量なコードのスレッド化が可能です。異なるスレッド化ライブラリを使用して最終実装を行う場合でも、スレッド化の利点の迅速なプロトタイピングや評価に非常に便利です。\n\
               \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F6\"></a>欠点は、アルゴリズムの適用に制約があり、実装間に互換性がないことです。VS2005 と Intel OpenMP ライブラリは併用できますが、相互の実装は認識されません。したがって、Intel\n\
               コンパイラでコンパイルした関数をコールする VC2005 でコンパイルしたスレッド化ループでは、Intel コンパイラで定義した OpenMP ロックはすべて無視されます。\n\
               \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F5\"></a>OpenMP では、ネストされたスレッド化にも問題があります。この場合、より高レベルのスレッドが生成され、それ自体がより低レベルにスレッド化されるコードを呼び出します。これにより、システムのコアよりも多くのスレッドがアクティブになります。これは、<em class=\"strong\">オーバーサブスクリプション</em>と呼ばれ、パフォーマンスの低下を引き起こします。アプリケーションにスレッド化が追加されるにつれて、オーバーサブスクリプションの問題は大きくなります。これは、並列でコールされている関数自体がスレッド化されていることに開発者が気付いていない場合があるためです。\n\
               \n\
               		\n\
            </p> \n\
            <p><em class=\"strong\">オーバーサブスクリプション</em>は、評価マネージャが並列評価を行う際には特に問題となります。 \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70F4\"></a> \n\
            <h2><a name=\"GUID-91B6B5F9-0842-478C-B241-37E6CF1B1ED3\"></a>OpenMP と Maya のスピンウェイト時間\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F3\"></a>Maya の一部のアルゴリズム(流体やダイナミクス ソルバを含む)は、OpenMP を使用してスレッド化されています。ほとんどのデータ並列ループは Intel® Threading\n\
               Building Blocks (TBB)を使用するため、評価マネージャを使用する際の問題を回避しています。「<span class=\"char_link\"><a href=\"#!/url=./files/GUID-328D2310-7F66-4F35-8055-BB10D7B45D5F.htm\">Intel Threading Building Blocks</a></span>」を参照してください。\n\
               		\n\
            </p> \n\
            <p>通常、スピンウェイト時間はゼロに設定し、変更すべきではありません。プラグインで Intel OpenMP を使用し、スピンウェイト時間にゼロ以外の値を設定する場合は、Intel\n\
               コンパイラ バージョンのヘッダ ファイル <span class=\"code\" translate=\"no\">omp.h</span> を組み込むことにより <span class=\"code\" translate=\"no\">kmp_set_blocktime()</span> 関数を使用できます。\n\
               		\n\
            </p> \n\
            <p>ただしこれを行う場合、評価マネージャの並列評価の実行中にブロック時間を設定すると、プラグイン間で潜在的な競合状態が発生することにご注意ください。このような潜在的な競合状態を回避するには、評価の実行中ではなく、プラグインの初期化中にブロック時間を設定するようにします。また、プラグインを終了する前にスピンウェイト時間をゼロに戻し、制御を\n\
               Maya に返すことも忘れないでください: <span class=\"code\" translate=\"no\">kmp_set_blocktime(0);</span> \n\
            </p> \n\
            <p>Maya は、すべてのプラットフォームの OpenMP に Intel コンパイラを使用します。 \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";